package org.nakedobjects.example.expenses.claims;

import org.nakedobjects.applib.AbstractDomainObject;
import org.nakedobjects.applib.ApplicationException;
import org.nakedobjects.applib.annotation.Bounded;
import org.nakedobjects.applib.annotation.Hidden;
import org.nakedobjects.applib.annotation.Immutable;
import org.nakedobjects.applib.annotation.When;



@Bounded
@Immutable(When.ONCE_PERSISTED)
public class ExpenseType extends AbstractDomainObject {


	// {{ Title

	public String toString() {
		StringBuffer t = new StringBuffer();
		t.append(titleString);
		return t.toString();
	}
	
	// }}
	
	// {{ TitleString field
	private String titleString;
	public String getTitleString() {
        resolve(titleString);
	    return this.titleString;
	}
	public void setTitleString(String titleString) {
	    this.titleString = titleString;
        objectChanged();
	}
	// }}
	
	/**
	 * This method potentially allows each instance of ExpenseType to have the same icon as its corresponding classname.
	 */
    public String iconName() {
    	return getTitleString();
    }
    
	// {{ Corresponding Class
	private String correspondingClass;

	/**
	 * The fully-qualified path name for the class that this instance of ApplicationType
	 * corresponds to  -  typically a sub-class of Application
	*/
	@Hidden
	public String getCorrespondingClassName() {
		resolve(correspondingClass);
		return correspondingClass;
	}

	/**
	 * @see #geTitleString
	 */
	public void setCorrespondingClassName(String correspondingClass) {
		this.correspondingClass = correspondingClass;
		objectChanged();
	}
	
	/**
	 * Converts the correspondingClassName into a java.lang.class.
	 * @return
	 */
	public Class correspondingClass() {
		try {
            return Class.forName(getCorrespondingClassName());
        } catch (ClassNotFoundException e) {
              throw new ApplicationException("Not a valid class " + getCorrespondingClassName());
        }
	}
	// }}
}
